/* Generated by wayland-scanner 1.23.0 */

#ifndef TEST_DRIVER_SERVER_PROTOCOL_H
#define TEST_DRIVER_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_test_driver The test_driver protocol
 * @section page_ifaces_test_driver Interfaces
 * - @subpage page_iface_test_driver - 
 */
struct test_driver;
struct wl_callback;
struct wl_surface;

#ifndef TEST_DRIVER_INTERFACE
#define TEST_DRIVER_INTERFACE
/**
 * @page page_iface_test_driver test_driver
 * @section page_iface_test_driver_api API
 * See @ref iface_test_driver.
 */
/**
 * @defgroup iface_test_driver The test_driver interface
 */
extern const struct wl_interface test_driver_interface;
#endif

#ifndef TEST_DRIVER_DIRECTION_ENUM
#define TEST_DRIVER_DIRECTION_ENUM
enum test_driver_direction {
	TEST_DRIVER_DIRECTION_LEFT = 1,
	TEST_DRIVER_DIRECTION_RIGHT = 2,
};
/**
 * @ingroup iface_test_driver
 * Validate a test_driver direction value.
 *
 * @return true on success, false on error.
 * @ref test_driver_direction
 */
static inline bool
test_driver_direction_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case TEST_DRIVER_DIRECTION_LEFT:
		return version >= 1;
	case TEST_DRIVER_DIRECTION_RIGHT:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* TEST_DRIVER_DIRECTION_ENUM */

/**
 * @ingroup iface_test_driver
 * @struct test_driver_interface
 */
struct test_driver_interface {
	/**
	 */
	void (*sync_actor_destroyed)(struct wl_client *client,
				     struct wl_resource *resource,
				     uint32_t callback,
				     struct wl_resource *surface);
	/**
	 */
	void (*sync_effects_completed)(struct wl_client *client,
				       struct wl_resource *resource,
				       uint32_t callback,
				       struct wl_resource *surface);
	/**
	 */
	void (*sync_window_shown)(struct wl_client *client,
				  struct wl_resource *resource,
				  uint32_t callback,
				  struct wl_resource *surface);
	/**
	 */
	void (*sync_point)(struct wl_client *client,
			   struct wl_resource *resource,
			   uint32_t sequence,
			   struct wl_resource *surface);
	/**
	 */
	void (*verify_view)(struct wl_client *client,
			    struct wl_resource *resource,
			    uint32_t callback,
			    uint32_t sequence);
	/**
	 */
	void (*move_to)(struct wl_client *client,
			struct wl_resource *resource,
			struct wl_resource *surface,
			int32_t x,
			int32_t y);
	/**
	 */
	void (*tile)(struct wl_client *client,
		     struct wl_resource *resource,
		     struct wl_resource *surface,
		     uint32_t direction);
};

#define TEST_DRIVER_SYNC_EVENT 0
#define TEST_DRIVER_PROPERTY 1
#define TEST_DRIVER_PROPERTY_INT 2

/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_EVENT_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_PROPERTY_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_PROPERTY_INT_SINCE_VERSION 1

/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_ACTOR_DESTROYED_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_EFFECTS_COMPLETED_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_WINDOW_SHOWN_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_POINT_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_VERIFY_VIEW_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_MOVE_TO_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_TILE_SINCE_VERSION 1

/**
 * @ingroup iface_test_driver
 * Sends an sync_event event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
test_driver_send_sync_event(struct wl_resource *resource_, uint32_t sequence)
{
	wl_resource_post_event(resource_, TEST_DRIVER_SYNC_EVENT, sequence);
}

/**
 * @ingroup iface_test_driver
 * Sends an property event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
test_driver_send_property(struct wl_resource *resource_, const char *name, const char *value)
{
	wl_resource_post_event(resource_, TEST_DRIVER_PROPERTY, name, value);
}

/**
 * @ingroup iface_test_driver
 * Sends an property_int event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
test_driver_send_property_int(struct wl_resource *resource_, const char *name, uint32_t value)
{
	wl_resource_post_event(resource_, TEST_DRIVER_PROPERTY_INT, name, value);
}

#ifdef  __cplusplus
}
#endif

#endif
